/*                     __                                               *\
**     ________ ___   / /  ___     Scala API                            **
**    / __/ __// _ | / /  / _ |    (c) 2003-2007, LAMP/EPFL             **
**  __\ \/ /__/ __ |/ /__/ __ |    http://scala-lang.org/               **
** /____/\___/_/ |_/____/_/ | |                                         **
**                          |/                                          **
\*                                                                      */

// $Id: EmptyMap.scala 10200 2007-03-04 10:33:14Z mihaylov $



package scala.collection.immutable

import Predef.Pair

/** This class implements empty immutable maps
 *  @author  Martin Oderskty
 *  @version 1.0, 019/01/2007
 */
@serializable
class EmptyMap[A, +B] extends Map[A, B] {

  def size: Int = 0

  def get(key: A): Option[B] = None

  def elements: Iterator[(A, B)] = Iterator.empty

  def empty[C]: Map[A, C] = new EmptyMap[A, C]

  def update [B1 >: B](key: A, value: B1): Map[A, B1] = 
    new Map1(key, value)

  def - (key: A): Map[A, B] = this
}
  


